#include <bits/stdc++.h>

using namespace std;
void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}

#define int long long
#define endl '\n'
const int N=30,MOD=1e9+7,INF=2e18;
struct seg_tree {
    pair<int,int> tmx[4*N];
    int th[4*N];
    int maxl[4*N],maxr[4*N];
    int modl[4*N],modr[4*N];
    void start() {
        fill(modl,modl+4*N,-INF);
        fill(modr,modr+4*N,-INF);
    }
    void push(int v,int l,int r) {
        if (modl[v]!=-INF){
            int len=r-l+1;
            maxl[v]=modl[v]*len;
            if (l!=r) {
                modl[v*2]=modl[v];
                modl[v*2+1]=modl[v];
            }
            modl[v]=-INF;
        }
        if (modr[v]!=-INF){
            int len=r-l+1;
            maxr[v]=modr[v]*len;
            if (l!=r) {
                modr[v*2]=modr[v];
                modr[v*2+1]=modr[v];
            }
            modr[v]=-INF;
        }
    }
    void build(int v,int l,int r,vector<int>&a) {
        if (l==r) {
            tmx[v]={a[l],l};
            th[v]=a[l];
            maxl[v]=a[l];
            maxr[v]=a[l];
            return;
        }
        int m=(l+r)/2;
        build(v*2,l,m,a);
        build(v*2+1,m+1,r,a);
        tmx[v]=max(tmx[v*2],tmx[v*2+1]);
        th[v]=th[v*2]+th[v*2+1];
        maxl[v]=maxl[v*2]+maxl[v*2+1];
        maxr[v]=maxr[v*2]+maxr[v*2+1];
    }
    pair<int,int> get(int v,int l,int r,int tl,int tr) {
        push(v,l,r);
        if (l>=tl && r<=tr) {
            return tmx[v];
        }
        if (l>tr || r<tl) {
            return {-INF,-INF};
        }
        int m=(l+r)/2;
        auto lv=get(v*2,l,m,tl,tr);
        auto rv=get(v*2+1,m+1,r,tl,tr);
        return max(lv,rv);
    }
    int get_h(int v,int l,int r,int tl,int tr) {
        push(v,l,r);
        if (l>=tl && r<=tr) {
            return th[v];
        }
        if (l>tr || r<tl) {
            return 0;
        }
        int m=(l+r)/2;
        int lv=get_h(v*2,l,m,tl,tr);
        int rv=get_h(v*2+1,m+1,r,tl,tr);
        return lv+rv;
    }
    int get_maxr(int v,int l,int r,int tl,int tr) {
        push(v,l,r);
        if (l>=tl && r<=tr) {
            return maxr[v];
        }
        if (l>tr || r<tl) {
            return 0;
        }
        int m=(l+r)/2;
        int lv=get_maxr(v*2,l,m,tl,tr);
        int rv=get_maxr(v*2+1,m+1,r,tl,tr);
        return lv+rv;
    }
    int get_maxl(int v,int l,int r,int tl,int tr) {
        push(v,l,r);
        if (l>=tl && r<=tr) {
            return maxl[v];
        }
        if (l>tr || r<tl) {
            return 0;
        }
        int m=(l+r)/2;
        int lv=get_maxl(v*2,l,m,tl,tr);
        int rv=get_maxl(v*2+1,m+1,r,tl,tr);
        return lv+rv;
    }
    void upd_maxl(int v,int l,int r,int tl,int tr,int val) {
        push(v,l,r);
        if (l>=tl && r<=tr) {
            modl[v]=val;
            push(v,l,r);
            return;
        }
        if (l>tr || r<tl) {
            return;
        }
        int m=(l+r)/2;
        upd_maxl(v*2,l,m,tl,tr,val);
        upd_maxl(v*2+1,m+1,r,tl,tr,val);
        maxl[v]=maxl[v*2]+maxl[v*2+1];
    }
    void upd_maxr(int v,int l,int r,int tl,int tr,int val) {
        push(v,l,r);
        if (l>=tl && r<=tr) {
            modr[v]=val;
            push(v,l,r);
            return;
        }
        if (l>tr || r<tl) {
            return;
        }
        int m=(l+r)/2;
        upd_maxr(v*2,l,m,tl,tr,val);
        upd_maxr(v*2+1,m+1,r,tl,tr,val);
        maxr[v]=maxr[v*2]+maxr[v*2+1];
    }
};

struct seg_help {
    int t[4*N];
    int mod[4*N];

    void push(int v,int l,int r) {
        if (mod[v]!=0) {
            t[v]+=mod[v];
            if (l!=r) {
                mod[v*2]+=mod[v];
                mod[v*2+1]+=mod[v];
            }
            mod[v]=0;
        }
    }
    void build(int v,int l,int r) {
        if (l==r) {
            t[v]=l;
            return;
        }
        int m=(l+r)/2;
        build(v*2,l,m);
        build(v*2+1,m+1,r);
        t[v]=max(t[v*2],t[v*2+1]);
    }
    int getl(int v,int l,int r,int val) {
        push(v,l,r);
        if (l==r) {
            return l;
        }
        int m=(l+r)/2;
        push(v*2,l,m);
        push(v*2+1,m+1,r);
        if (t[v*2]>=val) {
            return getl(v*2,l,m,val);
        }else {
            return getl(v*2+1,m+1,r,val);
        }
    }
    int getr(int v,int l,int r,int val) {
        push(v,l,r);
        if (l==r) {
            return l;
        }
        int m=(l+r)/2;
        push(v*2,l,m);
        push(v*2+1,m+1,r);
        if (t[v*2]>val) {
            return getr(v*2,l,m,val);
        }else {
            return getr(v*2+1,m+1,r,val);
        }
    }
    void update(int v,int l,int r,int tl,int tr,int val) {
        push(v,l,r);
        if (l>=tl && r<=tr) {
            mod[v]+=val;
            push(v,l,r);
            return;
        }
        if (l>tr || r<tl)return;
        int m=(l+r)/2;
        update(v*2,l,m,tl,tr,val);
        update(v*2+1,m+1,r,tl,tr,val);
        t[v]=max(t[v*2],t[v*2+1]);
    }
};
seg_help th;
seg_tree t;

void solve() {
    int n;
    cin>>n;
    vector<int> h(n);
    for (int i=0;i<n;i++) {
        cin>>h[i];
    }

    vector<int> r(n+1,n),l(n+1,-1);
    vector<int> st;
    for (int i=0;i<n;i++) {
        while (!st.empty() && h[st.back()]<=h[i]) {
            st.pop_back();
        }
        if (!st.empty()) {
            l[i]=st.back();
        }
        st.push_back(i);
    }
    st.clear();
    for (int i=0;i<n;i++) {
        while (!st.empty() && h[st.back()]<h[i]) {
            r[st.back()]=i;
            st.pop_back();
        }
        st.push_back(i);
    }

    t.start();
    t.build(1,0,n-1,h);
    th.build(1,0,n);
    for (int i=0;i<n-1;i++) {
        int k;
        cin>>k;
        k--;
        int lf=th.getl(1,0,n,k);
        int rf=th.getr(1,0,n,k)-1;
        int ls=rf+1;
        int rs=th.getr(1,0,n,k+1)-1;

        auto [mxf,pf]=t.get(1,0,n-1,lf,rf);
        auto [mxs,ps]=t.get(1,0,n-1,ls,rs);
        int ansl=0,ansr=0;
        if (mxf>mxs) {
            t.upd_maxl(1,0,n-1,ls,rs,mxf);
            ansr=t.get_maxr(1,0,n-1,ls,rs);
            ansr-=t.get_h(1,0,n-1,ls,rs);
            int pos=l[ps];
            if (pos+1<=rf) {
                t.upd_maxr(1,0,n-1,pos+1,rf,mxs);
                ansl+=t.get_maxr(1,0,n-1,pos+1,rf);
                ansl-=t.get_h(1,0,n-1,pos+1,rf);
            }
            if (lf<pf) {
                ansl+=t.get_maxl(1,0,n-1,lf,pf-1);
                ansl-=t.get_h(1,0,n-1,lf,pf-1);
            }
        }else if(mxf<mxs) {
            t.upd_maxr(1,0,n-1,lf,rf,mxs);
            ansl=t.get_maxl(1,0,n-1,lf,rf);
            ansl-=t.get_h(1,0,n-1,lf,rf);
            int pos=r[pf];
            if (ls<pos) {
                t.upd_maxl(1,0,n-1,ls,pos-1,mxf);
                ansr+=t.get_maxl(1,0,n-1,ls,pos-1);
                ansr-=t.get_h(1,0,n-1,ls,pos-1);
            }
            if (pf<rs) {
                ansr+=t.get_maxr(1,0,n-1,pf+1,rs);
                ansr-=t.get_h(1,0,n-1,pf+1,rs);
            }
        }else {
            t.upd_maxl(1,0,n-1,ls,rs,mxf);
            t.upd_maxr(1,0,n-1,lf,rf,mxs);
            ansr=t.get_maxr(1,0,n-1,ls,rs);
            ansr-=t.get_h(1,0,n-1,ls,rs);
            ansl=t.get_maxl(1,0,n-1,lf,rf);
            ansl-=t.get_h(1,0,n-1,lf,rf);
        }
        cout<<ansl+ansr<<endl;
        th.update(1,0,n,ls,n,-1);
    }
}